//+------------------------------------------------------------------+
//|                                                     IniFiles.mqh |
//|                                             . aka KimIV |
//|                                              http://www.kimiv.ru |
//|   25.04.2006       INI-.       |
//+------------------------------------------------------------------+
#property library
#import "kernel32.dll"
  int GetPrivateProfileStringA
      ( string SectionName,    //  
        string KeyName,        //  
        string Default,        //   
        string ReturnedString, //   
        int    nSize,          //     
        string FileName);      //   
  int WritePrivateProfileStringA
      ( string SectionName,    //  
        string KeyName,        //  
        string sString,        //   
        string FileName);      //   
#import
//+------------------------------------------------------------------+
//| :                                                       |
//|   FileName    -                                    |
//|   SectionName -                                |
//|   KeyName     -                             |
//|   aiParam     -               |
//+------------------------------------------------------------------+
void ReadIniArrayInt(string FileName, string SectionName, string KeyName, 
                     int& aiParam[])
  {
   int    i = 0, np;
   string Default = "", st, ReturnedString = "                      " + 
          "                                                         " + 
          "                                                         " + 
          "                                                         " + 
          "                                                              ";
   int nValue = GetPrivateProfileStringA(SectionName, KeyName, Default, 
                                         ReturnedString, 255, FileName);
   if(nValue > 0)
     {
       while(StringLen(ReturnedString) > 0)
         {
           np = StringFind(ReturnedString, ",");
           if(np < 0)
             {
               st = ReturnedString;
               ReturnedString = "";
             } 
           else 
             {
               st = StringSubstr(ReturnedString, 0, np);
               ReturnedString = StringSubstr(ReturnedString, np + 1);
             }
           i++;
           ArrayResize(aiParam, i);
           aiParam[i-1] = StrToInteger(st);
         }
     } 
   else 
        ArrayResize(aiParam, 0);
  }
//+------------------------------------------------------------------+
//| :                                                       |
//|   FileName    -                                    |
//|   SectionName -                                |
//|   KeyName     -                             |
//|   bDefault    -                      |
//+------------------------------------------------------------------+
bool ReadIniBool(string FileName, string SectionName, string KeyName, 
                 bool bDefault = False)
  {
   string Default, ReturnedString = "";
   if(bDefault) 
       Default = "1"; 
   else 
       Default = "0";
   int nValue = GetPrivateProfileStringA(SectionName, KeyName, Default, 
                                         ReturnedString, 255, FileName);
   if(nValue > 0)
     {
       if(StringGetChar(ReturnedString, 0) == 49) 
           return(True); 
       else 
           return(False);
     } 
   else 
       return(bDefault);
  }
//+------------------------------------------------------------------+
//| :                                                       |
//|   FileName    -                                    |
//|   SectionName -                                |
//|   KeyName     -                             |
//|   dDefault    -                      |
//+------------------------------------------------------------------+
double ReadIniDouble(string FileName, string SectionName, string KeyName, 
                     double dDefault = 0.0)
  {
   string Default, ReturnedString = "";
   Default = DoubleToStr(dDefault, 8);
   int nValue = GetPrivateProfileStringA(SectionName, KeyName, Default, 
                                         ReturnedString, 255, FileName);
   if(nValue > 0)
       return(StrToDouble(ReturnedString));
   else 
       return(dDefault);
  }
//+------------------------------------------------------------------+
//| :                                                       |
//|   FileName    -                                    |
//|   SectionName -                                |
//|   KeyName     -                             |
//|   iDefault    -                      |
//+------------------------------------------------------------------+
int ReadIniInteger(string FileName, string SectionName, string KeyName, 
                   int iDefault = 0)
  {
   string Default, ReturnedString = "";
   Default = DoubleToStr(iDefault, 0);
   int nValue = GetPrivateProfileStringA(SectionName, KeyName, Default, 
                                         ReturnedString, 255, FileName);
   if(nValue > 0)
       return(StrToInteger(ReturnedString));
   else 
       return(iDefault);
  }
//+------------------------------------------------------------------+
//| :                                                       |
//|   FileName    -                                    |
//|   SectionName -                                |
//|   KeyName     -                             |
//|   Default     -                      |
//+------------------------------------------------------------------+
string ReadIniString(string FileName, string SectionName, string KeyName, 
                     string Default = "")
  {
   string ReturnedString = "";
   int nValue = GetPrivateProfileStringA(SectionName, KeyName, Default, 
                                          ReturnedString, 255, FileName);
   if(nValue > 0)
       return(ReturnedString);
   else 
       return(Default);
  }
//+------------------------------------------------------------------+
//| :                                                       |
//|   FileName    -                                    |
//|   SectionName -                                |
//|   KeyName     -                             |
//|   aiParam     -              |
//+------------------------------------------------------------------+
void WriteIniArrayInt(string FileName, string SectionName, string KeyName, 
                      int& aiParam[])
  {
   int    as = ArraySize(aiParam);
   string sString = "";
   for(int i = 0; i < as; i++)
     {
       sString = sString + DoubleToStr(aiParam[i], 0);
       if(i < as - 1) 
           sString = sString + ",";
     }
   int nValue = WritePrivateProfileStringA(SectionName, KeyName, sString, 
                                           FileName);
  }
//+------------------------------------------------------------------+
//| :                                                       |
//|   FileName    -                                    |
//|   SectionName -                                |
//|   KeyName     -                             |
//|   bParam      -                     |
//+------------------------------------------------------------------+
void WriteIniBool(string FileName, string SectionName, string KeyName, 
                  bool bParam)
  {
   string sString;
   if(bParam) 
       sString = "1"; 
   else 
       sString = "0";
   int nValue = WritePrivateProfileStringA(SectionName, KeyName, sString, 
                                           FileName);
  }
//+------------------------------------------------------------------+
//| :                                                       |
//|   FileName    -                                    |
//|   SectionName -                                |
//|   KeyName     -                             |
//|   dParam      -                     |
//+------------------------------------------------------------------+
void WriteIniDouble(string FileName, string SectionName, string KeyName, 
                    double dParam)
  {
   string sString = DoubleToStr(dParam, 8);
   int nValue = WritePrivateProfileStringA(SectionName, KeyName, sString, 
                                           FileName);
  }
//+------------------------------------------------------------------+
//| :                                                       |
//|   FileName    -                                    |
//|   SectionName -                                |
//|   KeyName     -                             |
//|   iParam      -                     |
//+------------------------------------------------------------------+
void WriteIniInteger(string FileName, string SectionName, string KeyName, 
                     int iParam)
  {
   string sString = DoubleToStr(iParam, 0);
   int nValue = WritePrivateProfileStringA(SectionName, KeyName, sString, 
                                           FileName);
  }
//+------------------------------------------------------------------+
//| :                                                       |
//|   FileName    -                                    |
//|   SectionName -                                |
//|   KeyName     -                             |
//|   sParam      -                     |
//+------------------------------------------------------------------+
void WriteIniString(string FileName, string SectionName, string KeyName, 
                    string sParam)
  {
   int nValue = WritePrivateProfileStringA(SectionName, KeyName, sParam, 
                                           FileName);
  }
//+------------------------------------------------------------------+

